/*
@BAlign  @P@ICopyright Gold Disk Inc., February, 1992
This Genie aligns multiple boxes at a specified position. Click on each box to be aligned and then click on the artboard or in empty space when finished selecting boxes.
*/
cr     = '0a'x
counter     = 0
address command
call SafeEndEdit.rexx()
units = ppm_GetUnits()
if units = 3 then
    call ppm_SetUnits(1)

signal on halt
signal on break_c
signal on break_e
signal on break_d

/* Prompt user to click on boxes to be aligned
 * if the user clicks on the page or the art board
 * a boxnumber of 0 will be returned, use that
 * to exit loop
 */
do forever

    box = ppm_ClickOnBox( "Click on boxes to be aligned" )

    if box = 0 then leave

    counter = counter + 1
    boxes.counter = box /*  store box number in compound variable   */
    call ppm_SelectBox(box)

end

if counter = 0 then exit_msg()
/*  Prompt use to enter alignment - L, R, T, B, CV, CH   */
align = "Left"cr"Right"cr"Top"cr"Bottom"cr"Center Vertically"cr"Center Horizontally"
align = ppm_SelectFromList("Select alignment..", 30, 5, 0, align)
if align = '' then exit_msg()

select 
   when align = 'Left' then pos = word(ppm_GetBoxPosition(boxes.1),1)
   when align = 'Right' then pos = word(ppm_GetBoxPosition(boxes.1),1) + word(ppm_GetBoxSize(boxes.1),1)
   when align = 'Top' then pos = word(ppm_GetBoxPosition(boxes.1),2)
   when align = 'Bottom' then pos = word(ppm_GetBoxPosition(boxes.1),2) + word(ppm_GetBoxSize(boxes.1),2)
   when align = 'Center Horizontally' then pos = word(ppm_GetBoxPosition(boxes.1),2) + word(ppm_GetBoxSize(boxes.1),2) / 2
   when align = 'Center Vertically' then pos = word(ppm_GetBoxPosition(boxes.1),1) + word(ppm_GetBoxSize(boxes.1),1) / 2
end

if units = 3 then
    pos = ppm_ConvertUnits(1,3, pos)

position = ppm_GetForm( "Enter Position", 8, "Position:"pos)
if position = '' then exit_msg()

if ~datatype(position, n) then
    call exit_msg('Invalid Input')

if units = 3 then
   position = ppm_ConvertUnits(3, 1, position)

/*  Create a function to align the boxes    */
newpos = ''
newpos = SetAlignment(align)

call ppm_AutoUpdate(0)

/*  Loop through the boxes and interpret the function which aligns them */
do i = 1 to counter

    boxpos  = ppm_GetBoxPosition( boxes.i )
    boxsize = ppm_GetBoxSize( boxes.i )

    interpret "call ppm_SetBoxPosition("newpos")"

end
call exit_msg()

break_d:
break_e:
break_c:
halt:
    call exit_msg("User aborted Genie!")
/*
 * exit_msg()
 *
 * Description:
 * Exits the Genie with a message
 *
 * Arguments:
 * Message to inform user
 */
exit_msg: procedure expose units
do
    parse arg message

    if message ~= '' then
      call ppm_Inform( 1, message, )

    call ppm_AutoUpdate( 1 )

    if units = 3 then call ppm_SetUnits(3)
    exit

end

/*
 * SetAlignment()
 *
 * Description:
 * Creates a small arexx program which aligns the boxes based upon input
 *
 * Arguments:
 * Current alignment settings
 *
 * Returns:
 * Returns a string which may be interpreted by arexx
 */

SetAlignment: procedure
do
    arg align

    if align = 'BOTTOM' then
   return("boxes.i, word(boxpos, 1), (position - word(boxsize, 2))")

    if align = 'TOP' then
   return("boxes.i, word(boxpos, 1), position")

    if align = 'RIGHT' then
   return("boxes.i, (position - word(boxsize, 1)), word(boxpos, 2)")

    if align = 'LEFT' then
   return("boxes.i, position, word(boxpos, 2)")

    if align = 'CENTER VERTICALLY' then
   return("boxes.i, (position - word(boxsize,1)/2), word(boxpos, 2)")

    if align = 'CENTER HORIZONTALLY' then
   return("boxes.i, word(boxpos, 1 ), (position - word(boxsize,2)/2)")


end
