/*
@BAlterBoxesOnPages  @P@ICopyright Gold Disk Inc. February, 1992.

This Genie will alter each box at a particular position on a range of pages. You will be prompted to select the box which occurs at a position on the range of pages.
Next you will be prompted to select an attribute to be changed. The change will take place on all boxes in the range which are in the same position as the one clicked on.
*/
cr = '0a'x
pageopts = "OODDEEVENAALL"
address command
call SafeEndEdit.rexx()
call ppm_AutoUpdate(0)
counter = 0

signal on error
signal on syntax


commands.1      = "Position"
commands.1.1    = "left:"cr"top:"
commands.1.2    = "verifynumbers"
commands.2      = "Angle"
commands.2.1    = "Angle:"
commands.2.2    = "verifynumbers"
commands.3      = "Margins"
commands.3.1    = "left:"cr"top:"cr"right:"cr"bottom:"
commands.3.2    = "verifynumbers"
commands.4      = "Standoff"
commands.4.1    = "Standoff:"
commands.4.2    = "verifynumbers"
commands.5      = "Size"
commands.5.1    = "width:"cr"height:"
commands.5.2    = "verifynumbers"
commands.6      = "Offset"
commands.6.1    = "X offset:"cr"Y offset:"
commands.6.2    = "verifynumbers"
commands.7      = "Lock"
commands.7.1    = "Enter Yes or No"
commands.7.2    = "yntonumbers"
commands.8      = "TextWrap"
commands.8.1    = "Enter Type:"cr"Side:"
commands.8.2    = "verifynumbers"
commands.9      = "Hide"
commands.9.1    = "Enter Yes or No"
commands.9.2    = "yntonumbers"
commands.10     = "Frame"
commands.10.1   = "Enter Yes or No"
commands.10.2   = "yntonumbers"
commands.11     = "Transparent"
commands.11.1   = "Enter Yes or No"
commands.11.2   = "yntonumbers"
commands.12     = "FrameData"
commands.12.1   = "Line Color:"cr"Fill Color:"cr"Line Weight:"cr"Line Pattern:"cr"Fill Pattern:"
commands.12.2   = ""
commands.13     = "Tabs"
commands.13.1   = "Tabs:"
commands.13.2   = "verifytabs"
commands.13.2    = "verifynumbers"

command = ''

do i = 1 to 13

    command = command||commands.i||cr

end

command = left(command, length(command) - 1)

boxpos	= ppm_GetClickPosition("Click on box to be altered on each page")
boxtop	= word(boxpos, 2)
boxleft = word(boxpos, 1)
box	= ppm_BoxAtPosn(boxleft, boxtop)
if box	= 0 then exit_msg()

command = ppm_SelectFromList("Select attribute to change..",30,5,0,command)
if command = '' then exit_msg()

do i = 1 to 13

    if command = commands.i then leave

end

if pos(':', commands.i.1) ~= 0 then
do
   interpret "settings = ppm_GetBox"command"(box)"
   commands.i.1 = stuffsettings(settings, commands.i.1)
end

args = ppm_GetForm("Enter Values for "command, min(length(commands.i.1), 40), commands.i.1)
if args = '' then exit_msg()

if command = "Tabs" then 
   args = verifytabs(args)
else
   args = separate(args, commands.i.2)

docstart = ppm_DocFirstPage()
docend = ppm_DocLastPage()
pages = upper(ppm_GetForm("Enter range of pages", 20, "From:"docstart'0a'x "To:"docend'0a'x "ODD/EVEN/ALL"))
if pages = '' then exit_msg()

parse var pages startpage '0a'x endpage '0a'x pageopt

if (startpage ~= '' & datatype(startpage) ~= NUM) | (endpage ~= '' & datatype(endpage) ~= NUM ) then exit_msg("Invalid Input")

increment = 1

/*
 *  Check error conditions
 */
if startpage < docstart then exit_msg('Invalid Range')
else if startpage > docend then exit_msg('Invalid Range')
if endpage < docstart then exit_msg('Invalid Range')
else if endpage > docend then exit_msg('Invalid Range')
if endpage < startpage then exit_msg('Invalid Range')

if pageopt = 'ALL' | pageopt = 'A' then
do
    increment = 1
end
else if pageopt = 'EVEN' | pageopt = 'E' then
do
    increment	= 2
    if (startpage // 2) then startpage = startpage + 1
end
else if pageopt = 'ODD' | pageopt = 'O' then
do
    increment	= 2
    if ~(startpage // 2) then startpage = startpage + 1
end

if startpage > endpage then
do
    temp	= startpage
    startpage	= endpage
    endpage	= temp
end
page = ppm_GotoPage(startpage)
call ppm_AutoUpdate(0)
do while page <= endpage

    call  ppm_GotoPage(page)
    box = ppm_BoxAtPosn(boxleft, boxtop, page)
    if box ~= 0 then	interpret "call ppm_SetBox"command||"(box, "args")"
    page = page + increment

end
page = ppm_GotoPage(startpage)
exit_msg("Done")

error:
syntax:
do
    exit_msg("Genie failed due to error: "errortext(rc))
end

exit_msg:
do
    parse arg message

    if message ~= '' then
        call ppm_Inform(1, message,)

   call ppm_ClearStatus()
    call ppm_AutoUpdate(1)
    exit
end

separate:
do
    parse arg string, vfunction

    output  = ''

    do forever

        parse var string item '0a'x string

      if vfunction ~= '' then
           interpret "item = "vfunction"("item")"

        item = "'"item"'"

        if string = '' then 
            return(output||item)
        else
            output = output||item","
    end
end

verifynumbers: procedure
do
    parse arg number

    if ~datatype(number, n) then exit_msg("Invalid input")
    return(number)

end


yntonumbers: procedure 
do
    parse arg type

    type = upper(type)

    if left(type, 1) = "Y" then return(1)
    if left(type, 1) = "N" then return(0)
    call exit_msg("Invalid Entry")
end

verifytabs: procedure 
do
   parse arg tabs

   output = ''

   tabs = strip(tabs)

   do 16

      parse var tabs tab ' ' tabs

      if tab = '' then tab = 0
      if ~datatype(tab, n) then exit_msg("Invalid Entry")

      output = output" "tab

      tabs = strip(tabs)

   end

   return('"'output'"')
end


stuffsettings: procedure
do
   parse arg settings, prompt

   output = ''
   counter = 1
   colon = pos(':', prompt)
   cr = pos('0a'x, settings)

   if cr ~= 0 then
   do
	   do while colon ~= 0
	   	  
		  parse var settings default '0a'x settings

		  prompt = insert(default, prompt, colon)
	      colon = pos(':', prompt, colon + 1)

	   end

	   return(prompt)

  end



   do while colon ~= 0

      prompt = insert(word(settings, counter), prompt, colon)
      counter = counter + 1

      colon = pos(':', prompt, colon + 1)
   end

   prompt = prompt" " || subword(settings, counter)

   return(prompt)

end
