/*
AutoImportText

This Genie will import text and create as many pages (copies of the current page, if any) as necessary to fit the text. "Essays" have indented paragraphs with a half-line gap between them.
"Scripts" set margins as follows: paragraphs without codes are left unchanged; paragraphs beginning with a " are set as dialogue. Paragraphs beginning with : or ; are set as names of speakers. Character actions/manners of speaking are coded with a ( .
In all cases type is 14 point.


Written by Don Cox, Feb. 94, based on a Gold Disk original. Debug, June 94. Script format added Oct 94, Nov 94. Bug fixes Dec 94. Modified Feb 95. Bug fix, April 95. Bug fix, Sept. 95.
*/
/* $VER: AutoImportText Sept 95 */

/*call open("STDERR","ram:traceAIT","W")
trace r */ 

call SafeEndEdit.rexx()
call ppm_AutoUpdate(0)
currentunits = ppm_GetUnits()
call ppm_SetUnits(2)
address command

typesize = 14.000 /* You could change this */
bigtypesize = 24.000
currentpage = ppm_CurrentPage()

if currentpage ~= 0 then do /*  Page exists, select box */
    filename = ppm_GetFileName("Open Text File:", "", "")
    if filename = '' then call exit_msg()
    box = ppm_ClickOnBox("Click on box in which to import text")
    end

else do   /*  No page exists, make from default */
    filename = ppm_GetFileName("Open Text File:", "", "")
    if filename = '' then call exit_msg()
    currentpage = ppm_CreatePage(1,1,1,1,0)
    box = ppm_PageFirstBox(currentpage)
    if box = '' then call exit_msg("No box on default page, cannot import text.")
    end

startpage = currentpage

if box = 0 then exit_msg("No box selected")
info    = ppm_GetBoxInfo(box)
fword   = upper(word(info, 1))
lword   = word(info, words(info))

if (fword ~= "EMPTY" & lword ~= "0") then exit_msg("You must select an empty text box to use this Genie")
if word(info, 3) = 1 | word(info, 1) = word(info, 3) then leave

doparas = ppm_Inform(3, "Set paragraph indent?", "Essays", "Scripts", "No change")
donumbers = 1
if doparas = 2 then donumbers = ppm_Inform(2, "Number the pages?",,)

cpage = ppm_CurrentPage()
pagebox = 0 /* Is there a page number box already? */
testbox = ppm_PageFirstBox(cpage)
do until testbox=0
    info    = ppm_GetBoxInfo(box)
    fword   = upper(word(info, 1))
    lword   = word(info, words(info))
    if upper(fword)="TEXT" then do
        boxtxt = ppm_GetBoxText(testbox,1)
        if (words(boxtxt)=2 & pos("Page \#<Pc0>",boxtxt)~=0) then pagebox = 1
        end
    if pagebox = 1 then numberbox = testbox
    if pagebox = 1 then break
    testbox = ppm_PageNextBox(testbox)
    end
if (donumbers = 0 & pagebox = 1) then do
    DeleteIt = ppm_Inform(2, "Delete existing Page number box?",,)
    if DeleteIt = 1 then call ppm_DeleteBox(numberbox)
    end

/* make page number box */
if donumbers = 1 then do
    psize = ppm_GetPageSize(cpage)
    startpage = cpage
    pagewidth = word(psize,1)
    pageheight = word(psize,2)
    numberleft = pagewidth-6
    numbertop = pageheight-2
    numberbox = 0

    if pagebox = 0 then do
        numberbox = ppm_CreateBox(numberleft, numbertop,3,1,0,)
        call ppm_SetSize(12)
        overflow = ppm_TextIntoBox(numberbox,"\jl\fs<12.000>Page \#<Pc0>")
        end

    end

/* Go to first box of chain */
prevbox = box
outbox = 0

do forever
    prevbox = ppm_ArtNextBox(prevbox)
    if prevbox = 0 | ppm_BoxPage(prevbox) ~= currentpage then leave
    outbox = prevbox
end


if doparas = 1 then do
    call scriptimport /* pre-process script files */
    success = ppm_DefineParaTag("<mainpara{UcMl<0.0>Mr<0.0>PnPs<150>}>")
    success = ppm_DefineParaTag("<character{UcMl<0.0>Mr<0.0>PnPs<100>}>")
    success = ppm_DefineParaTag("<characterLive{UcMl<190.0>Mr<0.0>PnPs<100>}>")
    success = ppm_DefineParaTag("<dialogue{UcMl<100.0>Mr<100.0>PnPs<150>}>")
    success = ppm_DefineParaTag("<manner{UcMl<125.0>Mr<125.0>PnPs<100>}>")
    success = ppm_DefineParaTag("<mannerLive{UcMl<0.0>Mr<125.0>PnPs<100>}>")
    success = ppm_DefineStyleTag("<character{\dP<character>\fs<"typesize">\jc}>")
    success = ppm_DefineStyleTag("<dialogue{\dP<dialogue>\fs<"typesize">\jf}>")
    success = ppm_DefineStyleTag("<manner{\dP<manner>\fs<"typesize">\jf}>")
    success = ppm_DefineStyleTag("<characterLive{\dP<characterLive>\lr<180>\fs<"typesize">\jl}>")
    success = ppm_DefineStyleTag("<dialogueLive{\dP<dialogue>\lr<180>\fs<"typesize">\jl}>")
    success = ppm_DefineStyleTag("<mannerLive{\dP<mannerLive>\lr<180>\fs<"typesize">\jl}>")
    success = ppm_DefineStyleTag("<mainstyleLive{\dP<mainpara>\lr<180>\fs<"typesize">\jf}>")    
end

else if doparas = 0 then do
    success = ppm_DefineParaTag("<mainpara{Pi<0.5>Ps<150>}>")
    end

success = ppm_DefineParaTag("<quotes{Ml<80.0>Mr<80.0>PnPs<120>}>")
success = ppm_DefineParaTag("<address{UcMl<200>Mr<0.000>PnPs<110>SW<0>SC<0>Tb}>")
success = ppm_DefineParaTag("<solid{UcMbPnPs<100>SW<0>SC<0>Tb}>")

success = ppm_DefineStyleTag("<mainstyle{\dP<mainpara>\fs<"typesize">\jf}>")
success = ppm_DefineStyleTag("<quotes{\dP<quotes>\fs<"typesize">\I\jf}>")
success = ppm_DefineStyleTag("<heading{\dp\B\fs<"bigtypesize">\jl\lr<120>\c<Grey 15%>}>")
success = ppm_DefineStyleTag("<address{\dP<address>\fs<"typesize">\jr\lr<120>\c<Black>}>")
success = ppm_DefineStyleTag("<solid text{\dP<solid>\ff<(CG)Times>\fs<"typesize">\jl\K\H\lr<120>\c<Black>}>")
call ppm_SetStyleTag("mainstyle")


if ~ppm_ImportText(box, filename) then call exit_msg("Could not import "filename" - box not empty?") /* Box must be empty for flowing text */

call ppm_SetMagMode(100)
moretodo = ppm_TextOverFlow( box )

if ~moretodo then exit_msg("Done")
boxoff = boxoffset(box, currentpage)
if outbox = 0 then do
    outbox = box
    outboxoff = boxoff
    end
else
    outboxoff = boxoffset(outbox, currentpage)

do while moretodo
    call ppm_CopyPage(currentpage, currentpage, 1)
    call ppm_MovePage(currentpage, currentpage + 1)
    currentpage = currentpage + 1
    box = ppm_PageFirstBox(currentpage)
    fbox = box
    do boxoff
        box = ppm_PageNextBox(box)
        end
    call ppm_DeleteContents(box)
    call ppm_LinkBox(outbox, box)
    outbox = fbox
    do outboxoff
        outbox = ppm_PageNextBox(outbox)
        end
    moretodo = ppm_TextOverFlow(outbox)

    if moretodo then do
        info    = ppm_GetBoxInfo(box)
        b_width = word(info,5)
        if (b_width = 0) then exit_msg("Word too wide for box.")
        end
    end

newpage = ppm_GoToPage(startpage)
numpages = currentpage-startpage+1
if numpages = 1 then call ppm_DeleteBox(numberbox) /* Don't number 1 page */

call exit_msg("Made "numpages" pages")

/* +++++++++++++++++++++++++++++++  ++++++++++++++++++++++++++++++++  */

/* Box Offset Procedure */
boxoffset: procedure
do
    arg box, page
    cbox = ppm_PageFirstBox(page)
    bcount = 0
    do while cbox ~= 0
        if cbox = box then return(bcount)
        cbox = ppm_PageNextBox(cbox)
        bcount = bcount + 1
    end
    exit_msg("An internal error has occurred. Please try again")
end

/* ++++++++++++++++++++++++++++ ++++++++++++++++++++++++++++++++++++++++ */

/* Exit Msg Procedure */
exit_msg: 
do
    parse arg message
    if message ~= '' then call ppm_Inform(1, message,)
    call ppm_AutoUpdate(1)
    call ppm_SetUnits(currentunits)
    exit
end

/* ++++++++++++++++++++++++++++++ +++++++++++++++++++++++++++++++++++++++ */

scriptimport:

stype = ppm_Inform(3, "Type of Script?", "Abort", "Live Tape", "Film")
if stype = 0 then exit_msg("Aborted by User")


temptext="ram:temp.text"
call open("input",filename)
call open("temp",temptext,"W")
do until eof("input")
    instring = readln("input")
    outstring = ""
    if instring~="" then do
        stringlength = length(instring)
        instring = strip(instring,"B")
        
        firstchar = left(instring,1)
        parastring = ""
        select /* begin paras with a code character */
            when firstchar ="(" then parastring = "\dS<manner>"
            when firstchar ='"' then do
                parastring = "\dS<dialogue>"
                instring = strip(instring,"L",'"')
                end
            when firstchar =":" then do
                parastring = "\dS<character>"
                instring = strip(instring,"L",":")
                end
            when firstchar =";" then do
                parastring = "\dS<character>"
                instring = strip(instring,"L",";")
                end
            otherwise parastring = "\dS<mainstyle>"
            end
        if stype = 1 then do
            if parastring~= "" then parastring = compress(parastring,">")||"Live>"
            end
        outstring = parastring||instring
        end

    call writeln("temp",outstring)
    end
call close("temp")

filename = temptext
return