/*@BDropShadowHeader  @P@ICopyright Michael S. Fahrion, Feb, 1992

This genie creates a drop shadow for all the text in the selected box.
*/
call SafeEndEdit.rexx()
call ppm_AutoUpdate(0)
units = ppm_GetUnits()
if units = 3 then call ppm_SetUnits(1)

color = ppm_GetTextColor()
box   = ppm_ClickOnbox("Click on box for drop shadow text..")
if box = 0 then exit_msg()


if upper(word(ppm_GetBoxInfo(box), 1)) ~= 'TEXT' then
   exit_msg("The box must contain text..")

boxpos = ppm_GetBoxPosition(box)
boxleft = word(boxpos, 1)
boxtop = word(boxpos, 2)

text  = ppm_GetBoxText(box, 1)
if text = '' then exit_msg("No text in box")

call ppm_ShowStatus("Working..")
call SafeSetEdit.rexx(box)
size  = ppm_GetSize()
call SafeEndEdit.rexx()

offset = size / 1000
newbox   = ppm_CloneBox(box, offset, offset)

colorlist   = ppm_GetColorList()
colorlist   = delstr(colorlist, 1, pos('0a'x, colorlist))
color       = ppm_SelectFromList("Select Drop Shadow Color", 30, 5, 0, colorlist)
if color = '' then exit_msg()

call ppm_BoxToFront(box)
call SafeSetEdit.rexx(newbox)
call ppm_SelectBoxText()
call ppm_SetTextColor(color)
call SafeEndEdit.rexx()

exit_msg("Done")


exit_msg: procedure expose color units
do
   call ppm_SetTextColor(color)
   parse arg message


   if message ~= '' then
      call ppm_Inform(1, message,)

   call ppm_SetUnits(units)
   call ppm_ClearStatus()
   call ppm_AutoUpdate(1)
   exit
end



