/*
@BGroupCopyBoxContents @P@ICopyright Gold Disk Inc., Jan, 1993

This Genie will copy the contents of one box to all boxes in the current group.
*/
parse arg source
cr  = '0a'x
address command
call SafeEndEdit.rexx()
call ppm_AutoUpdate(0)
box = ppm_GroupFirstBox()
if box = 0 then exit_msg("Select a group first")

if source = '' then
do

    source  = ppm_ClickOnBox("Click on box which has contents to be copied..")
    if source = 0 then exit_msg()

end

info  = ppm_GetBoxInfo(source)
fword = upper(word(info, 1))

dellist = ''
grplist = ''

if fword = "TEXT" then
do
   copyfunc = "CopyText"
   text  = ppm_GetArticleText(source, 1)

end
else if fword = "EMPTY" then copyfunc = "DelContents"
else if fword = "STRUCTURED" | fword = "CLIP" then
do
   copyfunc = "CopyAll"
end
else if fword = "BITMAP" then
do
   copyfunc = "CopyBitMap"
   bitmapfile = substr(info, wordindex(info, 5))
end
else if fword = "EPSF" then
do
   copyfunc = "CopyEPSF"
   epsfile   = substr(info, wordindex(info, 3))
end

call ppm_ShowStatus("Working..")
do while box ~= 0

   interpret "call "copyfunc"(source, box)"
   box = ppm_GroupNextBox(box)

end

do while dellist ~= ''

   parse var dellist box ';' dellist

   if box ~= '' then call ppm_DeleteBox(box)

end

do while grplist ~= ''

   parse var grplist box ';' grplist

   if box ~= '' then call AddToGroup(box)

end

exit_msg()

CopyText: procedure expose text
do
   parse arg source, dest

   call ppm_DeleteContents(dest)
   call ppm_TextIntoBox(dest, text)
   return

end

DelContents: procedure
do
   parse arg source, dest
   call ppm_DeleteContents(dest)
   return
end

CopyEPSF: procedure expose epsfile
do
   parse arg source, dest

   call ppm_DeleteContents(dest)
   call ppm_ImportEPSF(dest, epsfile)
   return
end

CopyBitMap: procedure expose bitmapfile
do
   parse arg source, dest

   call ppm_DeleteContents(dest)
   call ppm_ImportBM(dest, bitmapfile)
   return
end

CopyAll: procedure expose dellist grplist
do
   parse arg source, dest

   dpos  = ppm_GetBoxPosition(dest)
   dsize = ppm_GetBoxSize(dest)
    ddata   = ppm_GetBoxFrameData(dest)
    dframe  = ppm_GetBoxFrame(dest)
    dboxoff = ppm_GetBoxOffset(dest)
    dangle  = ppm_GetBoxAngle(dest)
    dimperm = ppm_GetBoxTextWrap(dest)
    dlock   = ppm_GetBoxLock(dest)
    dhide   = ppm_GetBoxHide(dest)
    dtrans  = ppm_GetBoxTransparent(dest)
    dsoff   = ppm_GetBoxStandOff(dest)
    dmargs  = ppm_GetBoxMargins(dest)

    left    = word(dpos, 1)
    top     = word(dpos, 2)

    newbox  = ppm_CloneBox(source, 0, 0)

    call ppm_SetBoxSize(newbox, word(dsize, 1), word(dsize, 2))
    call ppm_SetBoxAngle(newbox, dangle)
    call ppm_SetBoxPosition(newbox, left, top)
    call ppm_SetBoxTextWrap(newbox, word(dimperm, 1), word(dimperm, 2))
    call ppm_SetBoxLock(newbox, dlock)
    call ppm_SetBoxHide(newbox, dhide)
    call ppm_SetBoxFrame(newbox, dframe)
    call ppm_SetBoxTransparent(newbox, dtrans)
    interpret "call ppm_SetBoxFrameData(newbox, "separate(ddata)")"
    interpret "call ppm_SetBoxOffset(newbox, "separate(dboxoff)")"
    interpret "call ppm_SetBoxStandOff(newbox, "separate(dsoff)")"
    interpret "call ppm_SetBoxMargins(newbox, "separate(dmargs)")"

   dellist = dellist';'dest
   grplist = grplist';'newbox
   return
end

separate: procedure
do
    parse arg string

    output = ''

        cr = pos('0a'x, string)

        if cr ~= 0 then
        do

                do while string ~= ''

                        parse var string val '0a'x string
                        output = output||"'"val"',"
                end
                output = delstr(output, length(output))
        end
        else
        do
            wrds    = words(string)

            do i = 1 to wrds - 1

                   output = output||word(string, i)", "

            end

            output = output || word(string, wrds)

        end

    return(output)

end

exit_msg: procedure
do
    parse arg message

    if message ~= '' then call ppm_Inform(1,message,)
    call ppm_ClearStatus()
    call ppm_AutoUpdate(1)
    exit
end


