/*
@BGroupRotate  @P@ICopyRight Gold Disk Inc., February, 1992

This Genie will rotate a group given an angle. This will only work for boxes that are on a page. Note that this Genie will rotate boxes @Iby@P the given angle not @Ito@P the given angle. The angle specified is added to the angle of each box in the group.
*/
numeric digits 8
rad = 3.1415926 / 180
address command
call SafeEndEdit.rexx()
call ppm_AutoUpdate(0)
units = ppm_GetUnits()
if units = 3 then
    call ppm_SetUnits(1)

signal on halt
signal on break_c
signal on break_e
signal on break_d

if ~show('l', "gdarexxsupport.library") then
    if ~addlib("gdarexxsupport.library",0,-30) then
            call exit_msg("Please install the gdarexxsupport.library in your libs: directory before running this Genie")

box     = ppm_GroupFirstBox()
if box  = 0 then exit_msg("Select a group first")

angle   = strip(ppm_GetForm("Rotation Angle", 8, "Angle"))
if angle = '' then exit_msg()

if  datatype(angle) ~= NUM then
    exit_msg("Invalid Input")

rangle  = angle * rad
cosa    = cos(rangle)
sina    = sin(rangle)

call ppm_ShowStatus("Working..")

grouprect   = ppm_GetGroupRect()
grpleft     = word(grouprect, 1)
grptop      = word(grouprect, 2)

do while box ~= 0

    boxpos  = ppm_GetBoxPosition(box)
    boxleft = word(boxpos, 1)
    boxtop  = word(boxpos, 2)

    call ppm_SetBoxAngle(box, angle + ppm_GetBoxAngle(box))

    xoffset = boxleft - grpleft
    yoffset = boxtop - grptop

    x   = grpleft + xoffset * cosa + yoffset * sina
    y   = grptop +  yoffset * cosa - xoffset * sina

    call ppm_SetBoxPosition(box, x, y)

    box = ppm_GroupNextBox(box)
end

exit_msg()
break_d:
break_e:
break_c:
halt:
    call exit_msg("User aborted Genie!")

exit_msg: procedure expose units
do
    parse arg message

    if message ~= '' then
        call ppm_Inform(1, message, )

    call ppm_ClearStatus()
	if units = 3 then call ppm_SetUnits(3)
    call ppm_AutoUpdate(1)
    exit

end
